/*
   FASTQ-Illumina-Filter
   Copyright (C) 2011  A. Gordon (gordon@cshl.edu)

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU Affero General Public License as
   published by the Free Software Foundation, either version 3 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Affero General Public License for more details.

   You should have received a copy of the GNU Affero General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef __STD_STRING_VALIDATIONS__
#define __STD_STRING_VALIDATIONS__

#include <string>

inline bool valid_nucleotide_string_N(const std::string& nuc)
{
	if (nuc.empty())
		return false;
	size_t found = nuc.find_first_not_of("ACGTN");
	return found==std::string::npos;
}

inline bool valid_nucleotide_string(const std::string& nuc)
{
	if (nuc.empty())
		return false;
	size_t found = nuc.find_first_not_of("ACGT");
	return found==std::string::npos;
}

inline bool valid_string_identifier(const std::string& id)
{
	if (id.empty())
		return false;
	size_t found = id.find_first_not_of("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ01234567890._-");
	return found==std::string::npos;
}

inline bool valid_string_integer(const std::string& id)
{
	if (id.empty())
		return false;
	size_t found = id.find_first_not_of("0123456789");
	return found==std::string::npos;
}

#endif
